
library static_test;

import "package:reflectable/reflectable.dart";

@MyReflectable()
class MyClass {
  static const String STATIC_STRING = "Some static content";

  MyClass();

  String instanceString = "Some instance content";
}


class MyReflectable extends Reflectable {
  // all capabilities
  const MyReflectable()
    : super.fromList(const [admitSubtypeCapability,
        classifyCapability,
        correspondingSetterQuantifyCapability,
        declarationsCapability,
        delegateCapability,
        instanceInvokeCapability,
        invokingCapability,
        libraryCapability,
        libraryDependenciesCapability,
        metadataCapability,
        nameCapability,
        newInstanceCapability,
        reflectedTypeCapability,
        staticInvokeCapability,
        subtypeQuantifyCapability,
        superclassQuantifyCapability,
        topLevelInvokeCapability,
        typeAnnotationDeepQuantifyCapability,
        typeAnnotationQuantifyCapability,
        typeCapability,
        typeRelationsCapability,
        typingCapability,
        uriCapability
  ]);
}

void main() {
  Reflectable myReflectable = const MyReflectable();
  ClassMirror myClassMirror =
      myReflectable.findLibrary("static_test").declarations["MyClass"];
  InstanceMirror myInstance = myReflectable.reflect(
      myClassMirror.newInstance("", []));

  print("Trying static getter on ClassMirror");
  try {
    print(myClassMirror.invokeGetter("STATIC_STRING"));
  } catch (e) {
    print(e);
  }

  print("Trying instance getter on InstanceMirror");
  try {
    print(myInstance.invokeGetter("instanceString"));
  } catch (e) {
    print(e);
  }

  print("Trying static getter on InstanceMirror");
  try {
    print(myInstance.invokeGetter("STATIC_STRING"));
  } catch (e) {
    print(e);
  }
}